/*
 * (C) Copyright 2000
 * Wolfgang Denk, DENX Software Engineering, wd@denx.de.
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#include <ppcboot.h>
#include "dipsw.h"
#include "lcd.h"

/* ------------------------------------------------------------------------- */

/*
 * Check Board Identity:
 */

int
checkboard(void)
{
    printf ("Cogent " COGENT_MOTHERBOARD " motherboard with a "
	COGENT_CPU_MODULE " CPU Module\n");
    return (0);
}

/* ------------------------------------------------------------------------- */

/*
 * Miscelaneous platform dependent initialisations while still
 * running in flash
 */

int
misc_init_f(void)
{
    printf ("  DIPSW: ");
    dipsw_init();
    return (0);
}

/* ------------------------------------------------------------------------- */

long int
initdram(int board_type)
{
    unsigned char dipsw_val;
    int dual, size0, size1;
    long int memsize;

    dipsw_val = dipsw_cooked();

    dual = dipsw_val & 0x01;
    size0 = (dipsw_val & 0x08) >> 3;
    size1 = (dipsw_val & 0x04) >> 2;

    if (size0)
	if (size1)
	    memsize = 16L * 1024L * 1024L;
	else
	    memsize =  1L * 1024L * 1024L;
    else
	if (size1)
	    memsize =  4L * 1024L * 1024L;
	else {
	    printf("[Illegal dip switch settings - assuming 16Mbyte SIMMs] ");
	    memsize = 16L * 1024L * 1024L; /* shouldn't happen - guess 16M */
	}

    if (dual)
	memsize *= 2L;

    return (memsize);
}

/* ------------------------------------------------------------------------- */

/*
 * Miscelaneous platform dependent initialisations after monitor
 * has been relocated into ram
 */

void
misc_init_r(bd_t *bd)
{
    printf ("  LCD:   ");
    lcd_init();

#if 0
    printf ("  RTC:   ");
    rtc_init();

    printf ("  PAR:   ");
    parallel_init();
#endif
}
